// The key used here is the sealing key

$ genkey(*sk, aik, p, pcr);

$ tpm(*aik, p);

$ safe();
$ attackbios();
$ attackloader();

! -[ ]-> k(bios[]);
! -[ ]-> k(loader[]);
! -[ ]-> k(fakebios[]);
! -[ ]-> k(fakeloader[]);

! -[tpm(|aik|, |p|)]-> k(srk(|aik|));
! -[tpm(|aik|, |p|)]-> k(|p|);
! -[tpm(|aik|, |p|)]-> k(pcrcert(|aik|, |p|));

! k(pcr), k(srk(|aik|)), genkey([sk], |aik|, |p|, pcr)
-[tpm(|aik|, |p|)]->
k(blob(|aik|, [sk], srk(|aik|), pcr));

! k(blob(|aik|, sk, pakey, pcr)), k(pakey)
-[tpm(|aik|, |p|)]->
k(pcrkey(|aik|, sk, pcr));

! k(pcrkey(|aik|, sk, |pcr|)), k(data), k(sealpcr)
-[tpm(|aik|, |pcr|)]->
k(seal(pk(sk), data, sealpcr));

! k(seal(pk(sk), data, h(h(boot[], fakebios[]), fakeloader[])))
, k(pcrkey(|aik|, sk, h(h(boot[], fakebios[]), fakeloader[])))
-[tpm(|aik|, h(h(boot[], fakebios[]), fakeloader[]))]->
k(data);

! k(seal(pk(sk), data, h(h(boot[], bios[]), fakeloader[])))
, k(pcrkey(|aik|, sk, h(h(boot[], bios[]), fakeloader[])))
-[tpm(|aik|, h(h(boot[], bios[]), fakeloader[]))]->
k(data);

! genkey([sk], bob[], p, pcr)
-[]-> 
k(seal(pk([sk]), vmk[], h(h(boot[], bios[]), loader[])));

! genkey([sk], bob[], p, pcr)
-[]->
k(pcrkey(bob[], [sk], h(h(boot[], bios[]), loader[])));

? k(n) -[ ]-> <tpm(|aik|, |p|), tpm(|aik|, h(|p|, n))>;
? -[ ]-> <tpm(|aik|, |p|), tpm(|aik|, boot[])>;

! k(vmk[]) -[tpm(bob[], h(h(boot[], fakebios[]), fakeloader[]))]-> attackbios();
! k(vmk[]) -[tpm(bob[], h(h(boot[], bios[]), fakeloader[]))]-> attackloader();

% tpm(|aik|, boot[]) * true;
% tpm(bob[], boot[]) * false;