// The key used here is the binding key

$ genkey(*sk, aik, p, pcr);
$ init(*n, p);
$ gensrt(*s, p, pkey);

$ tpm(*aik, p);
$ secret(*s, p, pkey);
$ alice(*n, p);

$ opened();
$ revoked();
$ attack();

! k(sk) -[ ]-> k(pk(sk));
! k(mess), k(pkey) -[ ]-> k(aenc(mess, pkey));
! k(p), k(n) -[ ]-> k(h(p, n));

! -[ ]-> k(revoke[]);
! -[ ]-> k(open[]);

! -[tpm(|aik|, |p|)]-> k(srk(|aik|));
! -[tpm(|aik|, |p|)]-> k(|p|);
! -[tpm(|aik|, |p|)]-> k(pcrcert(|aik|, |p|));

! gensrt([s], |p|, |pkey|), k(keycert(bob[], |pkey|, h(|p|, open[])))
-[alice(|n|, |p|)]-> k(aenc([s], |pkey|));

! k(pcr), k(srk(|aik|)), genkey([sk], |aik|, |p|, pcr)
-[tpm(|aik|, |p|)]->
k(blob(|aik|, [sk], srk(|aik|), pcr));

! k(blob(|aik|, sk, pakey, pcr)), k(pakey)
-[tpm(|aik|, |p|)]->
k(pcrkey(|aik|, sk, pcr));

! k(pcrkey(|aik|, sk, pcr))
-[tpm(|aik|, |p|)]->
k(keycert(|aik|, pk(sk), pcr));

! k(aenc(data, pk(sk))), k(pcrkey(|aik|, sk, |p|))
-[tpm(|aik|, |p|)]->
k(data);

? k(n) -[ ]->
<tpm(|aik|, |p|), tpm(|aik|, h(|p|, n))>;

? init([n],|p|) -[ ]->
< , alice([n], h(|p|, [n]))>, <tpm(bob[], |p|), tpm(bob[], h(|p|, [n]))>;

? gensrt([s], |p|, pkey), k(keycert(bob[], pkey, h(|p|, open[])))
-[alice(|n|, |p|)]->
< , secret([s], |p|, pkey)>;

? -[ ]-> <tpm(|aik|, |p|), tpm(|aik|, boot[])>;

! gensrt([s], |p|, |pkey|), k([s]) -[secret([s], |p|, |pkey|)]-> opened();
! gensrt([s], |p|, |pkey|), k(pcrcert(bob[], h(|p|, revoke[]))) -[secret([s], |p|, |pkey|)]-> revoked();
! gensrt([s], |p|, |pkey|), k([s]), k(pcrcert(bob[], h(|p|, revoke[]))) -[secret([s], |p|, |pkey|)]-> attack();

% tpm(|aik|, |p|) * true;
% tpm(bob[], |p|) * false;
