$ initA(skA, skR, *Na);
$ initB(skI, skB, *Nb);

$ Alice(skA, skR, *Na);
$ Bob(skI, skB, *Nb);

$ finished();
$ attackNa();
$ attackNb();

! k(sk) -[]-> k(pk(sk));
! k(m), k(sk) -[]-> k(sign(m, sk));
! k(sign(m, sk)) -[]-> k(m);
! k(m), k(pk(sk)) -[]-> k(aenc(m, pk(sk)));
! k(sk), k(aenc(m, pk(sk))) -[]-> k(m);

! k(x), k(y) -[]-> k(tuple2(x, y));
! k(tuple2(x, y)) -[]-> k(x);
! k(tuple2(x, y)) -[]-> k(y);

! -[]-> k(pk(skA[]));
! -[]-> k(pk(skB[]));

! initA(skA[], skR, [Na]), k(pk(skR)) -[]-> k(aenc(tuple2([Na], pk(skA[])), pk(skR)));
? initA(skA[], skR, [Na]), k(pk(skR)) -[]-> <, Alice(skA[], skR, [Na])>;

! initB(skI, skB[], [Nb]), k(aenc(tuple2(Na, pk(skI)), pk(skB[])))
-[]-> k(aenc(tuple2(Na, [Nb]), pk(skI)));
? initB(skI, skB[], [Nb]), k(aenc(tuple2(Na, pk(skI)), pk(skB[])))
-[]-> <, Bob(skI, skB[], [Nb])>;

! initA(skA[], |skR|, [Na]), k(aenc(tuple2([Na], Nb), pk(skA[])))
-[Alice(skA[], |skR|, [Na])]-> k(aenc(Nb, pk(|skR|)));

! initB(skA[], skB[], [Nb]), k(aenc([Nb], pk(skB[]))) -[Bob(skA[], skB[], [Nb])]-> finished();

! initA(skA[], |skR|, [Na]), k([Na]) -[Alice(skA[], |skR|, [Na])]-> attackNa();
! initB(skA[], skB[], [Nb]), k([Nb]) -[Bob(skA[], skB[], [Nb])]-> attackNb();


